/*
			
			My Window Definition Procedure
			
			
			This is that odd window.
			
			
			89/04/20
			
			
			1.0	  89/03/31	First draft based on clock window def proc (+A5 games ).
				  89/04/05	Fixed problem with zoom box hilite
				  89/04/06	Fixed zooming
				  89/04/07	Minor changes in draw, chose from two gray patterns
							to avoid odd mismatches in window dragged onscreen 
							from offscreen, added proper plainDBox & altDBoxProc 
							variations, special cased zero width titles.
			1.1	  89/04/09	Odd half erased scroll bar startup MPW adjusted
							[see DrawMyGrowIcon()]
			1.2	  89/04/09	Fixed problem with userState updates. Working on colors!
				  89/04/11	Changed size box to chevrons.
				  89/04/12	Made sure inGrow only returned on hilited windows.
				  89/04/20	Added Apples screenBits workaround and scroll area 
				  			to grow image.
			2.0   89/11/10  Finished color additions and cleaned up other
							assorted bugs. JNP
			
							Changes made by Josh Pritikin ( 11.10.89 ):
					1. In CalculateMyWindow I added a test to see if we have a color window.
					2. I removed the ugly StuffHex calls and speeded the pattern packing up.
					3. I added a gunk of code and special casing to totally support ColorQD!
					4. The code is admitably gross in some (most) places but it works and should
						serve as an example of what not to make your code look like.

						GEnie:			J.Pritikin
						AppleLink:		D4991	( <- this will change soon )
						Internet:		6500stom@ucsbuxa.ucsb.edu
						
			3.0   93/03/22	Updated for full color support. Rewrote code for Think C 5.x.
							
							Changes made by Anthony D. Saxton ( 2/26/93 ):
					1.	Rewrote code throughout for more efficient use of Think C 5.x.
					2.	Added Color button Icons for 2, 4 and 8 bit modes.
					3.	Added support for colorized windows as well as Apples "Color" cdev.
					4.	Added support for ALL documented window types & frames for the others!
					5.	Corrected Icon bug and added 3D movement!
					6.	Corrected GoAway button presence in movable dialog windows.
			
			3.1	  93/04/13	Converted NeXT WDEF to TrUE NeXT WDEF.
							Corrected some memory wasting code.
							Converted the Icon Color Table to a global.
							Corrected Colors in 2-bit mode.
			
					
		The Copyright Notice in CopyRight() Is Not To Be Removed! Use Of This Code In
		Commercial Software By License Only. Contact Anthony D. Saxton, Of Elenay Creations
		For Licensing Information. Use Of This Code In FreeWare, Requires Only Contact Of
		Elenay Creations. This Copyright Applies To All Code Segments Of This WDEF. 
		
		All Changes Are Copyright 1993, by Elenay Creations
											5686 Big Sea Street
											Las Vegas, NV, USA
																89110
											(702) 453-0270
							
						AOL:			Elenay
						Internet:		elenay_creations@tcs.las-vegas.nv.us
			
			
			  Public Domain 1989 by Appropriate Technology
			
			Changes - Copyright 1993 by Elenay Creations
			
			
			Please send a copy of changes/improvements to:
			
			Eric Celeste, Appropriate Technology, 358 North Parkview, Columbus, OH 43209, USA.
			CompuServe: 76146,724. MacNET: Celeste.
			
			
			Note: This WDEF is coded in THINK C 5.0.3 from Think Technologies
			


*/

#include "TrUE NeXT.h"

pascal long main( int variation, WindowPtr window, int message, long parameter )
{
	long	result = 0L;			/* the return code for the function */
	THz		saveZone;
	
	saveZone = GetZone();
	if ( MFRunning() )
		SetZone( SystemZone() );
	
	switch( message ) 
	{
	case( wDraw ):
		DrawMyWindow( variation, window, parameter );
		break;
	case( wHit ):
		result = HitMyWindow( variation, window, parameter );
		break;
	case( wCalcRgns ):
		CalculateMyWindow( variation, window, parameter );
		break;
	case( wNew ):
		SetupWindow( variation, window, parameter );
		break;
	case( wDispose ):
		KillWindow( variation, window, parameter );
		break;
	case( wGrow ):
		GrowMyWindow( variation, window, parameter );
		break;
	case( wDrawGIcon ):
		DrawMyGrowIcon( variation, window, parameter );
		break;
	}
	
	SetZone( saveZone );
	return( result );
}

/*
			is MultiFinder Running?
*/
Boolean	MFRunning()
{
	Boolean		result;
	SysEnvRec	theWorld;
	
	result = false;
	if ( !SysEnvirons( 1, &theWorld ) )
		result = ( theWorld.machineType >= 0 ) &&
					( NGetTrapAddress( OSDispatchTrapNum, ToolTrap ) !=
												NGetTrapAddress( UnImplTrapNum, ToolTrap ) );
	return( result );
}

/*
			create an RGB gray of this brightness.
*/
RGBColor PackGray( int brightness )
{
	RGBColor	gray;
	
	gray.red =  brightness;
	gray.green =  brightness;
	gray.blue = brightness;
	return gray;
}

/*
			where was my window hit?
*/
long HitMyWindow( int variation, WindowPtr window, long parameter )
{
	Point	hitLocation;
	long	result;
	
	result = wNoHit;
	
	SetPt( &hitLocation, LoWord( parameter ), HiWord( parameter ) );
	
	if ( PtInRgn( hitLocation, theWindow.strucRgn ) )
	{
		Rect	windowRect,
				thisRect;
				
		windowRect = (**theWindow.strucRgn).rgnBBox;
		
		if ( PtInRgn( hitLocation, theWindow.contRgn ) )
		{
			result = wInContent;					/* in the content region */
			
			if ( theWindow.hilited )
				if ( (variation & 7) == documentProc )
				{
					SetRect( &thisRect,
						windowRect.right - 17,
						windowRect.bottom - 17,
						windowRect.right - 3,
						windowRect.bottom - 3
					);
					if ( PtInRect( hitLocation, &thisRect ) )
						result = wInGrow;
				}
		} else
		{
			switch( variation & 7 )
			{
			case( documentProc ):
			case( noGrowDocProc ):
			case( movableDBoxProc ):
			
				result = wInDrag;						/* in the drag area unless */
				
				if ( theWindow.hilited )
				{
					if ( theWindow.goAwayFlag && variation != movableDBoxProc )
					{
						SetRect( &thisRect,
							windowRect.right - 16,
							windowRect.top + 5,
							windowRect.right - 3,
							windowRect.top + 18
						);
						if ( PtInRect( hitLocation, &thisRect ) )
							result = wInGoAway;
					}
					if ( result == wInDrag && theWindow.zoomFlag )
					{
						SetRect( &thisRect,
							windowRect.left + 6,
							windowRect.top + 5,
							windowRect.left + 19,
							windowRect.top + 18
						);
						if ( PtInRect( hitLocation, &thisRect ) && theWindow.dataHandle  )
						{
							thisRect = (**theWindow.contRgn).rgnBBox;
							if ( EqualRect ( &(wDataHandle.stdState), &thisRect ) )
								result = wInZoomIn;
							else
							{
								wDataHandle.userState = thisRect;
								result = wInZoomOut;
							}
						} /* in the zoom box */
						
					} /* still dragging & zoomable */
					
				} /* a hilited window */
				
				if ( result == wInDrag )
				{
					thisRect = windowRect;
					thisRect.top = (**theWindow.contRgn).rgnBBox.top;
					if ( PtInRect( hitLocation, &thisRect ) )
						result = wNoHit;					// according to Apple's specs
//						result = wInContent;				// alternate result
				} /* below title bar */
				break;
				
			}	/* a moveable window */
			
		} /* else not in content region */
		
	} /* in the structure region */
	
	return( result );
} /* end of HitMyWindow() */

/*
			calculate the regions of my window
*/
CalculateMyWindow( int variation, WindowPtr window, long parameter )
{
	Rect	windowRect;
	
	windowRect = window->portRect;
											/* a fix for CWindowRecords */
	if( window->portBits.rowBytes < colorWindow ) /* Color Window? */
		OffsetRect( &windowRect, -window->portBits.bounds.left, -window->portBits.bounds.top );
	else
	{
		Rect	portR;
		
		portR = (**(*(CWindowPtr)window).portPixMap).bounds;
		OffsetRect( &windowRect,-portR.left, -portR.top );
	}
	
	RectRgn( theWindow.contRgn, &windowRect );
	
	if ( (variation & 8) && !EqualRect( &(wDataHandle.stdState),&windowRect ) )
		wDataHandle.userState = windowRect;

	switch ( variation & 7 )
	{
	case ( documentProc ):						/* a regular window */
	case ( noGrowDocProc ):						/* a regular window with no growing */
	case ( movableDBoxProc ):					/* a moveable dialog with no growing or close*/
		OpenRgn();
			InsetRect( &windowRect, -1, -1 );
			windowRect.top -= 20;				/* add room for the title bar */
			MoveTo( windowRect.left, windowRect.top );
			LineTo( windowRect.left, windowRect.bottom-1 );
			LineTo( windowRect.left+1, windowRect.bottom );
			LineTo( windowRect.right, windowRect.bottom );
			LineTo( windowRect.right, windowRect.top+1 );
			LineTo( windowRect.right-1, windowRect.top );
			LineTo( windowRect.left, windowRect.top );
		CloseRgn( theWindow.strucRgn );
		break;
	case ( dBoxProc ):							/* dialog box variation */
		OpenRgn();
			InsetRect( &windowRect, -8, -8 );
			MoveTo( windowRect.left, windowRect.top );
			LineTo( windowRect.left, windowRect.bottom-2 );
			LineTo( windowRect.left+2, windowRect.bottom );
			LineTo( windowRect.right, windowRect.bottom );
			LineTo( windowRect.right, windowRect.top+2 );
			LineTo( windowRect.right-2, windowRect.top );
			LineTo( windowRect.left, windowRect.top );
		CloseRgn( theWindow.strucRgn );
		break;
	case ( altDBoxProc ):						/* shadow box variation */
	case ( altDBoxProc + 4 ):					/* remain consistant W/ Apple */
		OpenRgn();
			InsetRect( &windowRect, -1, -1 );
			MoveTo( windowRect.left, windowRect.top );
			LineTo( windowRect.left, windowRect.bottom );
			LineTo( windowRect.left+2, windowRect.bottom );
			LineTo( windowRect.left+2, windowRect.bottom+2 );
			LineTo( windowRect.right+2, windowRect.bottom+2 );
			LineTo( windowRect.right+2, windowRect.top+2 );
			LineTo( windowRect.right, windowRect.top+2 );
			LineTo( windowRect.right, windowRect.top );
			LineTo( windowRect.left, windowRect.top );
		CloseRgn( theWindow.strucRgn );
		break;
	default:								/* plain box variation (plainDBox) and others */
		InsetRect( &windowRect, -1, -1 );
		RectRgn( theWindow.strucRgn, &windowRect );
		break;
	}
		
} /* end of CalculateMyWindow() */

/*
			set up the window
*/
SetupWindow( int variation, WindowPtr window, long parameter )
{
	theWindow.dataHandle = nil;
	
	theWindow.dataHandle = NewHandle( (long)sizeof( WSDRecord ) );
	wCTHandle = nil;									// initialize CTable
		
	if ( variation == ( documentProc+8 ) || variation == ( noGrowDocProc+8 ) ||
															variation == ( movableDBoxProc+8 ) )
	{
		theWindow.zoomFlag = true;
		if ( theWindow.dataHandle )
		{		
			OSErr		err;
			SysEnvRec	thisWorld;
			Rect		thisRect;
			
			err = SysEnvirons( 1, &thisWorld );
			if ( !err && thisWorld.hasColorQD )
			{
				GDHandle	thisDevice;
				
				thisDevice = GetMainDevice();
				thisRect = (**thisDevice).gdRect;
				thisRect.top += MBarHeight;
			} else
			{
				GrafPtr		savePort;
				GrafPort	tempPort;
				
				GetPort( &savePort );				/* finding screenBits w/o globals */
				OpenPort( &tempPort );
				thisRect = tempPort.portRect;
				SetPort( savePort ); 
				ClosePort( &tempPort );
				thisRect.top += MBarHeight;			/* make way for the menubar */
			}
			InsetRect( &thisRect, 2, 2 );			/* make way for edges */
			thisRect.top += 16;						/* make way for what's left of title */
			wDataHandle.stdState = thisRect;
			wDataHandle.userState = thisRect;
		}
	} else
		theWindow.zoomFlag = false;
		
	buttonState = 0;
	
} /* end of SetupWindow() */

/*
			kill the window
*/
KillWindow( int variation, WindowPtr window, long parameter )
{
	if ( theWindow.dataHandle  )
	{
		if ( wCTHandle )
		{
			DisposeHandle( wCTHandle );
			wCTHandle = nil;
		}
		DisposHandle( theWindow.dataHandle );
		theWindow.dataHandle = nil;
	}
} /* end of KillWindow() */

/*
			draw the growing outline, the pen is already set
*/
GrowMyWindow( int variation, WindowPtr window, long parameter )
{
	Rect		growingRect;
	
	growingRect = *(RectPtr)parameter;
	
	growingRect.top -= 21;									/* out to full size */
	growingRect.left -= 1;
	growingRect.bottom += 1;
	growingRect.right += 1;
	
	FrameRect( &growingRect );								/* the frame */
	
	growingRect.top += 20;
	
	MoveTo( growingRect.left, growingRect.top );			/* the title bar area */
	LineTo( growingRect.right, growingRect.top );
	
	MoveTo( growingRect.right - 16, growingRect.top ); 		/* the scroll area */
	LineTo( growingRect.right - 16, growingRect.bottom );
	MoveTo( growingRect.left, growingRect.bottom - 17 );
	LineTo( growingRect.right, growingRect.bottom - 17 );
	
} /* end of GrowMyWindow() */

/*
draw the size box and the scroll frame
*/
DrawMyGrowIcon( int variation, WindowPtr window, long parameter )
{
	SysEnvRec		thisWorld;
	Boolean			hasColorQD;
	Rect			thisRect;
	RGBColor		myRGB;
	RgnHandle		saveClip,
					tempRgn;
	
	
	SetPort( window );
	
	if ( !SysEnvirons( 1, &thisWorld ) )
		hasColorQD = thisWorld.hasColorQD;
	else
		hasColorQD = false;
	
	if ( hasColorQD )
	{
		AuxWinHandle	theAuxWin;
		
		theAuxWin = nil;
		GetAuxWin( window, &theAuxWin );
		if ( theAuxWin )
		{
			
/*		The code below makes sure the System 7 colors are found even when the window color
			table is defined with only 5 colors! This determines if the Grow Icon will be drawn
			in color or b/w. */
				
			if ( auxCTable->ctSize < 12 )
				GetAuxWin( nil, &theAuxWin );
				
			if ( auxCTable->ctSize >= 12 )
				myRGB =  auxCTable->ctTable[12].rgb;
			else
				myRGB.red = 0xFFFF;				// Don't force b/w if Color cdev not used
		}
	}
	
/*
draw scroll bar frame
*/
	thisRect = window->portRect;
	thisRect.left = thisRect.right - 15;
	MoveTo( thisRect.left, thisRect.top );
	LineTo( thisRect.left, thisRect.bottom );

	thisRect.top = thisRect.bottom - 15;
	thisRect.left = window->portRect.left;
	MoveTo( thisRect.left, thisRect.top );
	LineTo( thisRect.right, thisRect.top );
	
	thisRect.left = thisRect.right - 15;
	InsetRect( &thisRect, 1, 1 );
	EraseRect( &thisRect );
	
	/*
	draw the sizing box 
	*/

	saveClip = NewRgn();
	tempRgn = NewRgn();
	GetClip( saveClip );
	
	if ( hasColorQD && window->portBits.rowBytes < colorWindow )	// Color Window?
	{
		CGrafPtr	wPort;
		
		thisRect = (**theWindow.contRgn).rgnBBox;
		thisRect.left = thisRect.right - 13;
		thisRect.top = thisRect.bottom - 13;
		OffsetRect( &thisRect, -1, -1 );	
		GetCWMgrPort( &wPort );
		SetPort( wPort );
	}
	
	if ( theWindow.hilited )
	{
		if( hasColorQD )
		{
			GDHandle	aDevice;
			
			aDevice = GetDeviceList();
			do
			{
				if ( TestDeviceAttribute( aDevice, screenDevice ) &&
													TestDeviceAttribute( aDevice, screenActive ) )
				{
					HLockHi( aDevice );
					if ( RectInRgn( &(**aDevice).gdRect, saveClip ) )
					{
						Handle	theColors;
						
						theColors = wCTHandle;
						RectRgn( tempRgn, &(**aDevice).gdRect );
						SectRgn( saveClip, tempRgn, tempRgn );
						SetClip( tempRgn );
						if ( (**(**aDevice).gdPMap).cmpSize >= 2 && (myRGB.red+myRGB.green))
							PlotCICN( thisRect,
								"\xAA\xAA\xAA\x80\x95\x55\x55\x40\x9F\xFD\x55\x40\x9C"
								"\x0F\xFD\x40\x9C\x6C\x0D\x40\x9C\xAD\x6D\x40\x9F\xFD"
								"\x6D\x40\x97\x15\x6D\x40\x97\x15\x6D\x40\x97\x2A\xAD"
								"\x40\x97\xFF\xFD\x40\x95\x55\x55\x40\x95\x55\x55\x40",
							(**(**aDevice).gdPMap).cmpSize >= 4 ? theColors : nil );						// The Color Grow Icon!
						else
							PlotSICN( thisRect, 
								"\xFF\xF8\xAA\xA8\xFF\x50\xA3\xE8\xE6\x30\xAE\x68\xFE\x70"
								"\xB0\x68\xD0\x70\xB7\xE8\xDF\xF0\xAA\xA8\xD5\x50\x00\x00"
							);										// The b/w Grow Icon!
						}
					HUnlock( aDevice );
				}
			} while ( aDevice = GetNextDevice( aDevice ) );
		} else
			PlotSICN( thisRect, 
				"\xFF\xF8\xAA\xA8\xFF\x50\xA3\xE8\xE6\x30\xAE\x68\xFE\x70"
				"\xB0\x68\xD0\x70\xB7\xE8\xDF\xF0\xAA\xA8\xD5\x50\x00\x00"
			);													// The b/w Grow Icon Again!
	}
	
	SetClip( saveClip );
	DisposeRgn( saveClip );
	DisposeRgn( tempRgn );

	SetPort( window );

} /* end of DrawMyGrowIcon() */

/*
			draw the frame w/ color shadowing.
*/
DrawFrame( PatsPtr pat, Rect frame, int width, int drawColor )
{
	frame.right -= 2;
	frame.bottom -= 2;
	
	PenSize( width, width );
	if ( drawColor )
		RGBForeColor( drawColor - 1 ? &pat->cFrameL : &pat->cWhite );
	else
		PenPat( &pat->white );
	FrameRect( &frame );
	
	OffsetRect( &frame, 2, 2 );
	if ( drawColor  )
		RGBForeColor( drawColor - 1 ? &pat->cFrameD : &pat->cDark );
	else
		PenPat( &pat->black );
	FrameRect( &frame );

	OffsetRect( &frame, -1, -1 );
	if ( drawColor )
		RGBForeColor( &pat->cLight );
	else
		PenPat( &pat->gray );
	FrameRect( &frame );
} /* end of DrawFrame() */

/*
			draw an empty pane w/ shadowing
*/
DrawPane( PatsPtr pat, Rect thisRect, int drawColor )
{
	/* fill the area with white */
	if ( drawColor )
	{
		RGBForeColor( drawColor - 1 ? &pat->cFrameL : &pat->cWhite );
		PenPat( &pat->black );
	} else
		PenPat( &pat->white );
	PaintRect( &thisRect );
	
	/* add the bottom shadow */
	PenSize( 1, 1 );
	if ( drawColor )
		RGBForeColor( &pat->cLight );
	else
		PenPat( &pat->black );
	MoveTo( thisRect.left+1, thisRect.bottom-1 );
	LineTo( thisRect.right-1, thisRect.bottom-1 );
	LineTo( thisRect.right-1, thisRect.top+1 );
	
	/* add the top shadow */
	if ( drawColor )
		RGBForeColor( drawColor - 1 ? &pat->cFrameD : &pat->cDark );
	MoveTo( thisRect.left, thisRect.bottom-1 );
	LineTo( thisRect.left, thisRect.top );
	LineTo( thisRect.right-1, thisRect.top );
} /* end of DrawPane() */

/*
			draw the title into the pane.
*/
DrawWindowTitle( WindowPtr window, Rect titleRect, PatsPtr pat, Boolean hilited, int drawColor )
{
	int			saveFont,
				saveSize;
	Style		saveFace;
	Str255		windowTitle;
	int			titleWidth, titleCenter;
	GrafPtr		wPort;
	
	GetPort( &wPort );
	saveFont = wPort->txFont;
	saveSize = wPort->txSize;
	saveFace = wPort->txFace;

	if ( drawColor )
	{
		TextFont( helvetica );
		TextSize( 12 );
		TextFace( bold );
	}else
	{
		TextFont( geneva );
		TextSize( 9 );
		TextFace( plain );
	}
	GetWTitle( window, windowTitle );
	
	titleWidth = StringWidth( windowTitle );
	titleCenter = titleRect.left + ((titleRect.right - titleRect.left) / 2);
	
	if ( titleWidth > 0 )
	{
		RgnHandle	saveClip,
					myClip;

		titleWidth += 12;						/* enough for edges */
	
		if ( (titleRect.right - titleRect.left) > titleWidth )
		{
			titleRect.right = titleCenter + titleWidth/2;
			titleRect.left = titleCenter - titleWidth/2;
		}
		if ( hilited && !drawColor ) DrawPane( pat, titleRect, drawColor );
		
		/* now shrink the box & set the clip region in case of a long title */
		saveClip = NewRgn();
		myClip = NewRgn();
		GetClip( saveClip );
		if ( !drawColor )
			InsetRect( &titleRect, 1, 1 );
		RectRgn( myClip, &titleRect );
		SectRgn( saveClip, myClip, myClip );
		SetClip( myClip );
		
		/* now position ourselves & draw the title */
		PenPat( &pat->black );
		if ( drawColor )
		{
			if ( hilited )
			{
				RGBForeColor( drawColor - 1 ? &pat->cFrameL : &pat->cWhite );
				RGBBackColor( &pat->cBlack );
			} else
			{
				RGBForeColor( drawColor - 1 ? &pat->cFrameD : &pat->cDark );
				RGBBackColor( &pat->cLight );
			}
		}
		
		MoveTo( titleRect.left + 6, titleRect.bottom - 2 - (drawColor>0) );
		DrawString( windowTitle );
		
		SetClip( saveClip );
		DisposeRgn( saveClip );
		DisposeRgn( myClip );
				
	} /* enough of a title to go with */
	
	TextFont( saveFont );
	TextSize( saveSize );
	TextFace( saveFace );
} /* end of DrawWindowTitle() */

/*
			animate the close icon.
*/
DrawGoAway( Rect frame, Boolean hilited, int drawColor, Handle theColors )
{
	if ( hilited  )
	{
		if ( drawColor )
			PlotCICN( frame,
						"\xAA\xAA\xAA\x80\x80\x00\x00\x00\x8A\x00\x28\x00\x8B"
						"\x80\xB8\x00\x82\xE2\xE0\x00\x80\xBB\x80\x00\x80\x2E"
						"\x00\x00\x80\xBB\x80\x00\x82\xE2\xE0\x00\x8B\x80\xB8"
						"\x00\x8A\x00\x28\x00\x80\x00\x00\x00\x80\x00\x00\x00",
						drawColor - 1 ? theColors : nil );	// goAwayDown
		else
			PlotSICN( frame,
						"\xFF\xF8\xAA\xA0\xD5\x50\xBA\xE0\xDD\xD0\xAF\xA0\xD7\x50"
						"\xAF\xA0\xDD\xD0\xBA\xE0\xD5\x50\xAA\xA0\x80\x00\x00\x00"
					);	// goAwayDown (b/w)
	} else
	{
		if ( drawColor )
			PlotCICN( frame,
						"\x00\x00\x00\x00\x15\x55\x55\x80\x1A\x55\x69\x80\x1B"
						"\x95\xB9\x80\x16\xE6\xE5\x80\x15\xBB\x95\x80\x15\x6E"
						"\x55\x80\x15\xBB\x95\x80\x16\xE6\xE5\x80\x1B\x95\xB9"
						"\x80\x1A\x55\x69\x80\x15\x55\x55\x80\x2A\xAA\xAA\x80",
						drawColor - 1 ? theColors : nil );	// goAwayUp
		else
			PlotSICN( frame,
						"\x00\x00\x2A\xA8\x55\x58\x3A\xE8\x5D\xD8\x2F\xA8\x57\x58"
						"\x2F\xA8\x5D\xD8\x3A\xE8\x55\x58\x2A\xA8\x7F\xF8\x00\x00"
					);	//	goAwayUp (b/w)
	}
} /* end of DrawGoAway() */

/*
			animate the zoom icon.
*/
DrawZoom( Rect frame, Boolean hilited, int drawColor, Handle theColors )
{
	if ( hilited )
	{
		if ( drawColor )
			PlotCICN( frame,
						"\xAA\xAA\xAA\x80\x80\x00\x00\x00\x8F\xFF\xFC\x00\x8F"
						"\xFF\xFC\x00\x8F\xFF\xFC\x00\x8D\x55\x5C\x00\x8D\x55"
						"\x5C\x00\x8D\x55\x5C\x00\x8D\x55\x5C\x00\x8D\x55\x5C"
						"\x00\x8F\xFF\xFC\x00\x80\x00\x00\x00\x80\x00\x00\x00",
						drawColor - 1 ? theColors : nil );	//	zoomDown
		else
			PlotSICN( frame,
						"\xFF\xF8\xAA\xA0\xFF\xF0\xBF\xE0\xFF\xF0\xA0\x20\xE0\x30"
						"\xA0\x20\xE0\x30\xA0\x20\xFF\xF0\xAA\xA0\x80\x00\x00\x00"
					);	//	zoomDown (b/w)
	} else
	{
		if ( drawColor )
			PlotCICN( frame,
						"\x00\x00\x00\x00\x15\x55\x55\x80\x1F\xFF\xFD\x80\x1F"
						"\xFF\xFD\x80\x1F\xFF\xFD\x80\x1D\x55\x5D\x80\x1D\x55"
						"\x5D\x80\x1D\x55\x5D\x80\x1D\x55\x5D\x80\x1D\x55\x5D"
						"\x80\x1F\xFF\xFD\x80\x15\x55\x55\x80\x2A\xAA\xAA\x80",
						drawColor - 1 ? theColors : nil );	//	zoomUp
		else
			PlotSICN( frame,
						"\x00\x00\x2A\xA8\x7F\xF8\x3F\xE8\x7F\xF8\x20\x28\x60\x38"
						"\x20\x28\x60\x38\x20\x28\x7F\xF8\x2A\xA8\x7F\xF8\x00\x00"
					);	// zoomup (b/w)
	}
} /* end of DrawZoom() */

/*
			draw the specified item
*/
DrawOnce( long param, int var, WindowPtr window, Rect windowRect, PatsPtr pat, int drawColor )
{
	Rect		thisRect;
	Handle		theColors;
				
	theColors = wCTHandle;
	
	switch ( (int)param )
	{
	case ( wNoHit ):
		
		thisRect = windowRect;

		PenNormal();
		
		/*  now for the more specific parts */
		switch ( var & 7 )
		{
		case ( documentProc ):					/* a regular window */
		case ( noGrowDocProc ):					/* a regular window with no grow box */
		case ( movableDBoxProc ):				/* a non-modal dialog */
			if ( drawColor )
				RGBForeColor( &pat->cBlack );
			PenPat( &pat->black );
			FrameRect( &thisRect );

			thisRect.bottom = thisRect.top + 21;
			FrameRect( &thisRect );
			InsetRect( &thisRect, 2, 2 );
			if ( drawColor )
			{
				if( theWindow.hilited )
					RGBForeColor( &pat->cBlack );
				else
					RGBForeColor( &pat->cLight );
			} else
				PenPat( &pat->gray );
			PaintRect( &thisRect );
			InsetRect( &thisRect, -1,-1 );
			if ( drawColor )
				RGBForeColor( drawColor - 1 ? &pat->cFrameD : &pat->cDark );
			else
				PenPat( &pat->black );
			PenSize( 1, 1 );
			MoveTo( windowRect.left+2, windowRect.top+19 );
			LineTo( windowRect.right-2, windowRect.top+19 );
			LineTo( windowRect.right-2, windowRect.top+2 );
			if ( drawColor )
				RGBForeColor( drawColor - 1 ? &pat->cFrameL : &pat->cWhite );
			else
				PenPat( &pat->white );
			MoveTo( windowRect.left+1, windowRect.top+19 );
			LineTo( windowRect.left+1, windowRect.top+1 );
			LineTo( windowRect.right-2, windowRect.top+1 );

			/*  the goaway box */
			if ( theWindow.goAwayFlag  && (var & 7) != movableDBoxProc )
			{
				SetRect( &thisRect, 
					windowRect.right 	- 17, 
					windowRect.top 		+ 4,
					windowRect.right 	- 4,
					windowRect.top 		+ 17
				 );
				DrawPane( pat, thisRect, drawColor );
				DrawGoAway( thisRect, false, drawColor, theColors );		
			}
			/*  the zoom box */
			if ( theWindow.zoomFlag )
			{
				SetRect( &thisRect, 
					windowRect.left 	+ 5, 
					windowRect.top 		+ 4,
					windowRect.left 	+ 18,
					windowRect.top 		+ 17
				 );
				DrawPane( pat, thisRect, drawColor );
				DrawZoom( thisRect, false, drawColor, theColors );		
			}
			if ( theWindow.hilited )
			{
				/*  the title */
				SetRect( &thisRect, 
					windowRect.left 	+ 21, 
					windowRect.top 		+ 3,
					windowRect.right 	- 21,
					windowRect.top 		+ 17
				 );
				PenSize( 1, 1 );
				if ( thisRect.right - thisRect.left > 0 )
					DrawWindowTitle( window, thisRect, pat, true, drawColor );
			} else
			{
				/*  the title */
				SetRect( &thisRect, 
					windowRect.left 	+ 21, 
					windowRect.top 		+ 3,
					windowRect.right 	- 21,
					windowRect.top 		+ 17
				 );
				if (!drawColor )
					DrawPane( pat, thisRect, drawColor );
				DrawWindowTitle( window, thisRect, pat, false, drawColor );
			}
			break;
		
		case ( dBoxProc ):						/* dialog box variation */
			DrawFrame( pat, thisRect, 4, drawColor );
			thisRect.right -= 2;
			thisRect.bottom -= 2;
			OffsetRect( &thisRect, 1, 1 );
			InsetRect( &thisRect, 5, 5 );
			PenSize( 2, 2 );
			if ( drawColor )
			{
				PenPat( &pat->black );
				RGBForeColor( &pat->cLight );
			} else
				PenPat( &pat->white );
			FrameRect( &thisRect );
			break;
		case ( altDBoxProc ):					/* shadow box variation */
		case ( altDBoxProc + 4 ):				/* remain consistant w/ Apple */
			thisRect.right -= 2;
			thisRect.bottom -= 2;
			FrameRect( &thisRect );
			PenSize( 2, 2 );
			if ( drawColor )
				RGBForeColor( &pat->cLight );
			MoveTo( thisRect.left + 2, thisRect.bottom );
			LineTo( thisRect.right, thisRect.bottom );
			LineTo( thisRect.right, thisRect.top + 2 );
			break;
		default:								/* plain box variation (plainDBox) and others */
			PenPat( &pat->black );
			FrameRect( &thisRect );
			break;
		}
		
		break;
		
	case ( wInGoAway ):
	
		SetRect( &thisRect, 						/* just toggle the goAway */
			windowRect.right 	- 17, 
			windowRect.top 		+ 4,
			windowRect.right 	- 4,
			windowRect.top 		+ 17
		 );
		buttonState = !buttonState;
		DrawGoAway( thisRect, buttonState, drawColor, theColors );		
		break;
		
	case ( wInZoomIn ):
	case ( wInZoomOut ):

		SetRect( &thisRect, 						/* just toggle the zoomBox */
			windowRect.left 	+ 5, 
			windowRect.top 		+ 4,
			windowRect.left 	+ 18,
			windowRect.top 		+ 17
		 );
		buttonState = !buttonState;
		DrawZoom( thisRect, buttonState, drawColor, theColors );
		break;
		
	default:
		break;
		
	}
} /* end of DrawOnce() */

/*
			drawing my window
*/
DrawMyWindow( int var, WindowPtr window, long param )
{
	SysEnvRec		thisWorld;
	CGrafPtr		wPort,
					savePort;
	Boolean			hasColorQD;
	
	PenState		savePen;
	RGBColor		savePnClr,
					saveBkClr;
	PixPatHandle	savePnPat,
					saveBkPat,
					saveFillPat;

	PatsRec			patStore;
	PatsPtr			pat;
	
	Rect			windowRect;
	
	savePnPat = nil;
	
	if ( !theWindow.visible ) return;
	
	pat = &patStore;
		
	if ( !SysEnvirons( 1, &thisWorld ) )
		hasColorQD = thisWorld.hasColorQD;
	else
		hasColorQD = false;
		
	
	if ( hasColorQD )
	{
		AuxWinHandle	theAuxWin;

		theAuxWin = nil;

		GetPort( &savePort );
		GetCWMgrPort( &wPort );
		SetPort( wPort );
		
		savePnPat = NewPixPat();
		saveBkPat = NewPixPat();
		saveFillPat = NewPixPat();
		
		CopyPixPat( wPort->pnPixPat, savePnPat );
		CopyPixPat( wPort->bkPixPat, saveBkPat );
		CopyPixPat( wPort->fillPixPat, saveFillPat );
		GetForeColor( &savePnClr );
		GetBackColor( &saveBkClr );
		
		pat->cBlack = PackGray( 0 );
		pat->cDark = PackGray( 0x5000 );
		pat->cLight = PackGray( 0xA000 );
		pat->cWhite = PackGray( 0xFFFF );
		pat->cFrameL = pat->cWhite;
		pat->cFrameD = pat->cDark;
		
		GetAuxWin( window, &theAuxWin );
		if ( theAuxWin )
		{
			HLockHi( (*theAuxWin)->awCTable );
								
	/*		The code below makes sure the System 7 colors are found even when the window color
				table is defined with only 5 colors! This defines the outline colors of the
				frame and buttons.	*/
				
			if ( auxCTable->ctSize < 12 )
				GetAuxWin( nil, &theAuxWin );
			if ( auxCTable->ctSize >= 12 )
			{			
				if ( auxCTable->ctTable[12].rgb.red + auxCTable->ctTable[12].rgb.green )
				{
					if ( !wCTHandle )	// Make Color Table Now, if not done...
					{								// We only use a ColorTable if System 7
						Handle			theColors;
		
						theColors = nil;
						theColors = NewHandle( 40 );				// theColorTable!

						if ( theColors )
						{
							int			i;
					
							HLock( theColors );
							
							(*(CTabHandle)theColors)->ctSeed = GetCTSeed();	//	Unique Seed
							(*(CTabHandle)theColors)->ctFlags = 0;			//	Empty for CTables
							(*(CTabHandle)theColors)->ctSize = 3;			//	4 Colors
					
							for ( i=0; i<=3; i++ )							// Colors in sequence
								(*(CTabHandle)theColors)->ctTable[i].value = i;
								
							(*(CTabHandle)theColors)->ctTable[1].rgb = pat->cLight;
							(*(CTabHandle)theColors)->ctTable[3].rgb = pat->cBlack;
							
							HUnlock( theColors );
							wCTHandle = theColors;
						}
					} else
					if( (auxCTable->ctTable[12].rgb.red &
							auxCTable->ctTable[12].rgb.green &
							auxCTable->ctTable[12].rgb.blue) != 0x3333 ) // disable Color Table if gray.
					{
						pat->cFrameL =  auxCTable->ctTable[11].rgb;
						pat->cFrameD =  auxCTable->ctTable[12].rgb;
					}
					if ( wCTHandle )		// update Icon colors for Sys 7
					{
						(*(CTabHandle)(wCTHandle))->ctTable[0].rgb = pat->cFrameL;
						(*(CTabHandle)(wCTHandle))->ctTable[2].rgb = pat->cFrameD;
					}
				} else
					hasColorQD=false;
			}
			HUnlock( (*theAuxWin)->awCTable );
		}
	}
	
	windowRect = (**theWindow.strucRgn).rgnBBox;
	
/*	Align the pattern to the position of the window to prevent shifting durring a drag. */
		
	pat->gray[0] = pat->gray[1] = (windowRect.left^windowRect.top) & 0x0001
		?gray1Hex
		:gray2Hex;
	
	pat->black[0] = pat->black[1] = blackHex;
	pat->white[0] = pat->white[1] = whiteHex;
	GetPenState( &savePen );
	
	if ( hasColorQD )
	{
		RgnHandle	saveClip,
					tempRgn;
		GDHandle	aDevice;
		
		saveClip = NewRgn();
		tempRgn = NewRgn();
		GetClip( saveClip );

		aDevice = GetDeviceList();
		do
		{
			if ( TestDeviceAttribute( aDevice, screenDevice ) &&
											TestDeviceAttribute( aDevice, screenActive ) )
			{
				HLockHi( aDevice );
				if ( RectInRgn( &(**aDevice).gdRect, saveClip ) )
				{
					RectRgn( tempRgn, &(**aDevice).gdRect );
					SectRgn( saveClip, tempRgn, tempRgn );
					SetClip( tempRgn );
					DrawOnce( param, var, window, windowRect, pat,
													((**(**aDevice).gdPMap).cmpSize - 1 ));
				}
				HUnlock( aDevice);
			}
		} while ( (aDevice = GetNextDevice( aDevice )) != nil );
	
		SetClip( saveClip );
		DisposeRgn( saveClip );
		DisposeRgn( tempRgn );
	} else
		DrawOnce( param, var, window, windowRect, pat, 0 );
	
	SetPenState( &savePen );
	if ( savePnPat )		// Since hasColorQD may have changed, we check for presence of Handle.
	{
		RGBForeColor( &savePnClr );
		RGBBackColor( &saveBkClr );
		
		CopyPixPat( savePnPat, wPort->pnPixPat );
		CopyPixPat( saveBkPat, wPort->bkPixPat );
		CopyPixPat( saveFillPat, wPort->fillPixPat );
		DisposPixPat( savePnPat );
		DisposPixPat( saveBkPat );
		DisposPixPat( saveFillPat );
		
		SetPort( savePort );
	}
} /* end of DrawMyWindow() */

/*
			draw a black and white Icon!
*/
PlotSICN( Rect theRect, Ptr theSICN )
{
	BitMap	srcBits;	/* built up around 'SICN' data so we can _CopyBits */
	GrafPtr	wPort;
	
	GetPort( &wPort );

	/* set up the small icon's bitmap */
	srcBits.baseAddr = theSICN;
	srcBits.rowBytes = 2;
	SetRect( &srcBits.bounds, 0, 0, 13, 13 );

								/* draw the small icon in the current grafport */
	CopyBits( &srcBits,&wPort->portBits,&srcBits.bounds,&theRect,srcCopy,nil );

} /* end of PlotSICN() */

/*
			draw a color icon!
*/
PlotCICN( Rect theRect, Ptr theCICN, Handle theColors )
{
	PixMap			srcBits;	// built up around 'CICN' data so we can _CopyBits
 	CGrafPtr		wPort;			
	RGBColor		savePnClr,
					saveBkClr,
					myRGB;

	GetForeColor( &savePnClr );
	myRGB = PackGray( 0x0000 );
	RGBForeColor( &myRGB );			// Black
	GetBackColor( &saveBkClr );
	myRGB = PackGray( 0xFFFF );
	RGBBackColor( &myRGB );			// White

 	GetPort( &wPort );
 	
	srcBits.baseAddr = theCICN;
 	srcBits.rowBytes = 0x8004;		// bit 15 indicates PixMap
 	SetRect( &srcBits.bounds, 0, 0, 13, 13 );
 	srcBits.pmVersion = srcBits.packType = srcBits.pixelType = 0;
 	srcBits.packSize = srcBits.planeBytes = srcBits.pmReserved = 0L;
 	srcBits.hRes = srcBits.vRes = 72;
	srcBits.pixelSize = srcBits.cmpSize = 2;
 	srcBits.cmpCount = 1; 	
 	srcBits.pmTable = (CTabHandle)theColors;						// nil if not created
	
 									//	draw the color icon in the current grafport
 	CopyBits( &srcBits,*wPort->portPixMap,&srcBits.bounds,&theRect,srcCopy,nil );
 	
	RGBForeColor( &savePnClr );
	RGBBackColor( &saveBkClr );
	
} /* end of PlotCICN() */

/*
			CopyRight Notice
*/
CopyRight()
{
	/*	The Following Copyright Notice Is Not To Be Removed! Use Of This Code In Commercial
		Software Will Be By License Only. Contact Anthony D. Saxton, Of Elenay Creations
		For Licensing Information. Use Of This Code In FreeWare, Requires Only Contact Of
		Elenay Creations. This Copyright Applies To All Code Segments Of This WDEF. */
		
	Str63	Copyright = "Copyright1993ElenayCreations,702/4530270,"
								"All Rights Reserved";
	
}